﻿using System;
using System.Collections.Generic;
using System.Reflection;
using System.Text;
using System.Windows.Forms;

namespace Střelci
{
	partial class AboutForm : Form
	{
		/// <summary>
		/// Vytvoří nový formulář informací o aplikaci.
		/// </summary>
		public AboutForm()
		{
			string desc, cr;

			InitializeComponent();

			// titulek
			this.Text = "O aplikaci " + Application.ProductName;

			// naplnime udaje
			titleLabel.Text = Application.ProductName;
			versionLabel.Left = titleLabel.Right;
			versionLabel.Text = Application.ProductVersion;
#if DEBUG
			versionLabel.Text += " ladící";
#endif
			// ziskame dalsi info
			GetAdditionalInfo(out desc, out cr);

			descriptionLabel.Text = desc;
			copyrightLabel.Text = cr;
		}

		/// <summary>
		/// Vrátí další informace o tomto kompletu.
		/// </summary>
		protected void GetAdditionalInfo(out string description, out string copyright)
		{
			Assembly a = Assembly.GetAssembly(this.GetType());
			object[] pole = a.GetCustomAttributes(true);
			AssemblyCopyrightAttribute atribut;
			AssemblyDescriptionAttribute popis;

			// vychozi hodnoty, pokud nenajdeme
			description = string.Empty;
			copyright = "© " + Application.CompanyName;

			// hledame
			foreach(object polozka in pole)
			{
				// kopyrajt
				atribut = polozka as AssemblyCopyrightAttribute;
				if(atribut != null)
					copyright = atribut.Copyright;
				else
				{
					// popis
					popis = polozka as AssemblyDescriptionAttribute;
					if(popis != null)
						description = popis.Description;
				}
			}
		}
	}
}