using System;
using System.Diagnostics;

namespace Stelci
{
	partial class ChessForm
	{
		/// <summary>
		/// Spust zptn pehrn ukonen partie.
		/// </summary>
		protected void Replay()
		{
			Debug.Assert(_CurrentGame != null, "Nemme partii.");
			Debug.Assert(_CurrentGame.State != GameState.NotStartedYet, "Hra jet nezaala.");
			Debug.Assert(_CurrentGame.State != GameState.Running, "Hra jet b.");

			HighlightedPlayer = SelectedPlayer.None;

			// a pak je po jednom budem zase pridavat
			replayTimer.Start();

			// vratime vsechny tahy
			NavigateTime(-(Game.CurrentMoveNumber-1));

			RefreshReplay();
		}

		/// <summary>
		/// Zru ppadn pehrvn partie.
		/// </summary>
		protected void CancelReplay()
		{
			// pokud bezi casovac,
			if(replayTimer.Enabled)
			{
				Debug.Assert(Game != null, "Pehrn je sputno, ale nemme partii.");
				Debug.Assert(!Game.Running, "Pehrvn je sputno, ale hra b.");

				// zastavime ho
				replayTimer.Stop();

				// a vratime hru na konec
				while(Game.CanRedo)
				{
					NavigateTime(1);
				}

				RefreshReplay();
			}
		}

		private void replayTimer_Tick(object sender, EventArgs e)
		{
			// posunem se na dalsi tah
			NavigateTime(1);

			// nemuzem-li uz dal,
			if(!Game.CanRedo)
			{
				// vypnem se
				replayTimer.Stop();

				RefreshMoveControls();
				RefreshReplay();
			}
		}

		private void replayToolStripMenuItem_Click(object sender, EventArgs e)
		{
			Replay();
		}

		/// <summary>
		/// Obnov monosti zptnho pehrn hry.
		/// </summary>
		protected void RefreshReplay()
		{
			// replay povolime, jenom, kdyz je partie dohrana a zrovna nebezi
			replayToolStripButton.Enabled = replayToolStripMenuItem.Enabled =
				_CurrentGame != null && !_CurrentGame.Running && !replayTimer.Enabled;
		}
	}
}