﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Střelci
{
	public partial class CounterForm : Form
	{
		public CounterForm()
		{
			InitializeComponent();

			RefreshList();
		}

		/// <summary>
		/// Obnoví seznam počítadel.
		/// </summary>
		protected void RefreshList()
		{
			countersListView.BeginUpdate();

			countersListView.Items.Clear();

			lock(ThinkingCounter.Instance)
			{
				foreach(KeyValuePair<string, int> p in ThinkingCounter.Instance)
				{
					// pridame do seznamu
					ListViewItem li = new ListViewItem(p.Key);
					li.SubItems.Add(p.Value.ToString("n"));
					countersListView.Items.Add(li);
				}
			}

			countersListView.EndUpdate();
		}

		private void refreshTimer_Tick(object sender, EventArgs e)
		{
			RefreshList();
		}
	}
}