﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Diagnostics;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

namespace Střelci
{
	partial class DebugForm : Form
	{
		private DebugFormListener m_Listener;

		public DebugForm()
		{
			InitializeComponent();

			// vytvorime pro sebe noveho posluchace
			m_Listener = new DebugFormListener(this);
			// pridame ho
			Debug.Listeners.Add(m_Listener);
		}

		private void clearLogToolStripButton_Click(object sender, EventArgs e)
		{
			// vymazeme text
			traceLogTextBox.Clear();
		}

		/// <summary>
		/// Zapíše do protokolu zprávu.
		/// </summary>
		/// <param name="message">Zpráva, která bude zapsána.</param>
		public void Write(string message)
		{
			traceLogTextBox.Text += message;
		}

		/// <summary>
		/// Zapíše do protokolu zprávu s odřádkováním.
		/// </summary>
		/// <param name="message">Zpráva, která bude zapsána.</param>
		public void WriteLine(string message)
		{
			traceLogTextBox.Text += message + Environment.NewLine;
		}

		private void DebugForm_FormClosed(object sender, FormClosedEventArgs e)
		{
			// uklid
			Debug.Listeners.Remove(m_Listener);
		}
	}
}