
namespace Stelci
{
	public partial class Judge
	{
		/// <summary>
		/// Pedstavuje filtr genertoru tah, kter zahrne vechny platn tahy.
		/// </summary>
		/// <param name="game">Partie, ve kter se tah odehrv.</param>
		/// <param name="move">Tah, kter se provede.</param>
		public static bool ValidMovesFilter(Game game, Move move)
		{
			// pouze zkontrolujeme platnost
			return game.Judge.IsValid(move, false);
		}

		/// <summary>
		/// Pedstavuje filtr genertoru tah, kter zahrne vechny platn zajmut.
		/// </summary>
		/// <param name="game">Partie, ve kter se tah odehrv.</param>
		/// <param name="move">Tah, kter se provede.</param>
		public static bool ValidCapturesFilter(Game game, Move move)
		{
			// zjistime, kdo stoji na cili
			Piece na_cili = move.Piece.Chessboard.GetPieceOnTile(move.To);
			// pokud tam nic neni, nebo to ma stejnou barvu, skoncime
			if(na_cili == null || na_cili.Color == move.Piece.Color)
				return false;
			
			// jinak vratime platne ohrozovani
			//return ValidThreatensFilter(game, move);
			return game.Judge.IsValid(move, false);
		}

		/// <summary>
		/// Pedstavuje filtr genertoru tah, kter zahrne vechna platn ohroovn.
		/// </summary>
		/// <param name="game">Partie, ve kter se tah odehrv.</param>
		/// <param name="move">Tah, kter se provede.</param>
		public static bool ValidThreatensFilter(Game game, Move move)
		{
			// vratime platne ohrozovani
			return game.Judge.IsValid(move, true);
		}
	}	
}
